package co.barkbuddy;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.SpinnerAdapter;

import co.barkbuddy.location.DoubleTapMapView;
import co.barkbuddy.location.MapFragment;
import co.barkbuddy.profile.ProfileActivity;

import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.SherlockFragmentActivity;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;

public class MainActivity extends SherlockFragmentActivity implements ActionBar.OnNavigationListener {
	
	ActionBar actionBar;
	MapFragment mapFragment;
	FriendsFragment friendsFragment;
		
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		actionBar = this.getSupportActionBar();
		
//		View view = getLayoutInflater().inflate(R.layout.actionbar_title, null);		
//		TextView title = (TextView)view.findViewById(R.id.actionbarTitle);
//		title.setText("barkbuddy");
//		title.setTypeface(Typeface.createFromAsset(getAssets(), "HennyPenny-Regular.ttf"));
//		actionBar.setCustomView(view);
		
		mapFragment = new MapFragment();
		friendsFragment = new FriendsFragment();
//		switchFragment(mapFragment, "MAP");
		
		SpinnerAdapter adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, android.R.id.text1, new String[] {"Map", "Friends", "Me"});
		
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_LIST);
		actionBar.setListNavigationCallbacks(adapter, this);
		actionBar.setDisplayShowCustomEnabled(true);
		actionBar.setDisplayShowTitleEnabled(false);
		actionBar.show();
		
//		locationListener = new BarkBuddyLocationListener(map);
//		locationManager = (LocationManager)this.getSystemService(Context.LOCATION_SERVICE);
	}

	private void switchFragment(Fragment suppliedFragment, String tag) {
		Fragment fragment = getSupportFragmentManager().findFragmentByTag(tag);
		if (fragment == null)
			fragment = suppliedFragment;
		FragmentTransaction transaction = this.getSupportFragmentManager().beginTransaction();
		transaction.replace(R.id.mainFrame, fragment, tag);
		transaction.commit();
	}
	
	@Override
	public void onStop() {
		super.onStop();
//		ParseUser.logOut();
	}
	
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = this.getSupportMenuInflater();
		inflater.inflate(R.menu.map_activity, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		
		Intent intent = null;
		boolean foundHandler = true;
		
		switch (item.getItemId()) {
        	case R.id.menu_settings:
        		intent = new Intent(this, ProfileActivity.class);
                break;    
        	default:
        		foundHandler = false;
		}

		if (intent != null)
			startActivity(intent);
		
		return foundHandler;
	}

	@Override
	public boolean onNavigationItemSelected(int itemPosition, long itemId) {
		switch (itemPosition) {
			case 0:
				switchFragment(mapFragment, "MAP");
				break;
			case 1:
				switchFragment(friendsFragment, "FRIENDS");
				break;
			case 2:
				break;
		}
		return true;
	}
	
	public void onZoomInClick(View button) {
		mapFragment.onZoomInClick(button);
	}
	
	public void onZoomOutClick(View button) {
		mapFragment.onZoomOutClick(button);
	}
	
	public void onLocateMeClick(View button) {
		mapFragment.onLocateMeClick(button);
	}
}
