package co.barkbuddy.location;

import android.content.Intent;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import co.barkbuddy.CheckinActivity;
import co.barkbuddy.LoginActivity;
import co.barkbuddy.R;

import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MyLocationOverlay;

public class MapFragment extends SherlockFragment {

	DoubleTapMapView map;
	LocationManager locationManager;
	BarkBuddyLocationListener locationListener;
	MyLocationOverlay myLocation;
	View view;
	
	@Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
		return view;
	}
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.setHasOptionsMenu(true);
		
		view = getActivity().getLayoutInflater().inflate(R.layout.map, null);
		
		map = (DoubleTapMapView)view.findViewById(R.id.map);
		map.setBuiltInZoomControls(false);
		
		myLocation = new MyLocationOverlay(getActivity(), map);
		map.getOverlays().add(myLocation);
		map.postInvalidate();
	}

	@Override
	public void onResume() {
		super.onResume();
//		locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, locationListener);
//		locationListener.onLocationChanged(locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER));
//		myLocation.enableMyLocation();
//		myLocation.runOnFirstFix(new Runnable() { 
//			public void run() {
//				map.getController().animateTo(myLocation.getMyLocation());
//		}});
//				
//	    if (LoginActivity.pd != null && LoginActivity.pd.isShowing())
//	    	LoginActivity.pd.dismiss();
	}
	
	@Override
	public void onPause() {
		super.onPause();
//		locationManager.removeUpdates(locationListener);
//		myLocation.disableMyLocation();
	}
	
	@Override
	public void onCreateOptionsMenu (Menu menu, MenuInflater inflater) {
		super.onCreateOptionsMenu(menu, inflater);
		inflater.inflate(R.menu.map_fragment, menu);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		
		Intent intent = null;
		
		switch (item.getItemId()) {
        	case R.id.menu_check_in:
        		intent = new Intent(getActivity(), CheckinActivity.class);
                break;       
		}

		if (intent != null)
			startActivity(intent);
		
		return true;
	}
	
	public void onZoomInClick(View button) {
		map.getController().zoomIn();
	}
	
	public void onZoomOutClick(View button) {
		map.getController().zoomOut();
	}
	
	final Handler handler = new Handler();
	
	public void onLocateMeClick(View button) {
//		locationManager.requestSingleUpdate(LocationManager.GPS_PROVIDER, locationListener, null);
//		this.runOnUiThread(new Runnable() {
//            @Override
//            public void run() {
//        		locationListener.animateTo(myLocation.getMyLocation());
//            }			
//		});

		GeoPoint point = myLocation.getMyLocation();
    	if (myLocation.getMyLocation() != null) {
    		map.getController().animateTo(point);
    	} else {
    		Toast.makeText(getActivity(), "Just a sec, looking you up...", 2000).show();
    	}
	}
}
