package co.barkbuddy.profile;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import co.barkbuddy.MainActivity;
import co.barkbuddy.R;
import co.barkbuddy.TabListener;
import co.barkbuddy.R.layout;
import co.barkbuddy.R.string;

import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.ActionBar.Tab;
import com.actionbarsherlock.app.SherlockFragment;
import com.actionbarsherlock.app.SherlockFragmentActivity;
import com.actionbarsherlock.view.MenuItem;

public class ProfileActivity extends SherlockFragmentActivity {

	ActionBar actionBar;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.setContentView(R.layout.profile);
		
		actionBar = this.getSupportActionBar();
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
		actionBar.setDisplayShowTitleEnabled(false);
		actionBar.setDisplayHomeAsUpEnabled(true);
		
		this.createTabs();
	}
	
	private void createTabs() {
		Tab ownerTab = actionBar.newTab()
            .setText(R.string.owner)
            .setTabListener(new TabListener<OwnerFragment>(
                    this, "owner", OwnerFragment.class));
	    actionBar.addTab(ownerTab);

	    Tab dogTab = actionBar.newTab()
	        .setText(R.string.dog)
	        .setTabListener(new TabListener<DogProfilesFragment>(
	                this, "dog", DogProfilesFragment.class));
	    actionBar.addTab(dogTab);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		
		Intent intent = null;
		
		switch (item.getItemId()) {
		      
        	case android.R.id.home:
        		intent = new Intent(this, MainActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                break;
		}

		if (intent != null)
			startActivity(intent);
		
		return true;
	}

	public static class OwnerFragment extends SherlockFragment {
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
			Log.d("DEBUG", "OwnerFragment.onCreateView");
			View view = inflater.inflate(R.layout.owner_profile, container, false);
			return view;
		}
	}

	public void onProfileImageClick(View view) {
		Intent intent = new Intent(this, ProfileImageActivity.class);
		startActivity(intent);
	}
}
